src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @ORM\Table(name="sp_user")
 * @UniqueEntity(fields={"email"}, message="There is already an account with this email")
 */
class User implements UserInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     */
    private $email;

    /**
     * @var String
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $vat_number;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $phone;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $logo;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $slug;

    /**
     * @ORM\Column(type="string", length=180)
     */
    private $account_type;

    /**
     * @ORM\OneToMany(targetEntity="Product", mappedBy="user", cascade={"persist", "remove"})
     */
    private $products;

    /**
     * @ORM\OneToMany(targetEntity="Ticket", mappedBy="client", cascade={"persist", "remove"})
     */
    private $ticketsFrom;

    /**
     * @ORM\OneToMany(targetEntity="Ticket", mappedBy="provider", cascade={"persist", "remove"})
     */
    private $ticketsFor;

    /**
     * @ORM\Column(type="string", length=180)
     */
    private $address;

    /**
     * @ORM\Column(type="json")
     */
    private $roles = [];

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private $password;

    /**
     * @ORM\Column(type="boolean")
     */
    private $isVerified = false;

    /**
     * @ORM\OneToMany(targetEntity=QuoteGeneration::class, mappedBy="client")
     */
    private $generation_from;

    /**
     * @ORM\OneToMany(targetEntity=QuoteGeneration::class, mappedBy="provider")
     */
    private $generation_to;

    /**
     * @ORM\Column(type="boolean")
     */
    private $is_subscribed = false;

    /**
     * @ORM\OneToMany(targetEntity=Notification::class, mappedBy="user")
     */
    private $notifications;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $created_at;

    /**
     * @ORM\OneToMany(targetEntity=Company::class, mappedBy="user")
     * @Assert\Count(max=3, maxMessage="Vous ne pouvez pas spécifier plus de {{ limit }} entreprises")
     */
    private $companies;

    /**
     * @ORM\Column(type="array")
     */
    private $regions = [];

    /**
     * @ORM\ManyToMany(targetEntity=Field::class, inversedBy="users")
     */
    private $fields;

    /**
     * @return mixed
     */
    public function getTicketsFrom()
    {
        return $this->ticketsFrom;
    }

    /**
     * @param mixed $ticketsFrom
     * @return User
     */
    public function setTicketsFrom($ticketsFrom)
    {
        $this->ticketsFrom = $ticketsFrom;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getTicketsFor()
    {
        return $this->ticketsFor;
    }

    /**
     * @param mixed $ticketsFor
     * @return User
     */
    public function setTicketsFor($ticketsFor)
    {
        $this->ticketsFor = $ticketsFor;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param mixed $name
     * @return User
     */
    public function setName($name)
    {
        $this->name = $name;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getVatNumber()
    {
        return $this->vat_number;
    }

    /**
     * @param mixed $vat_number
     * @return User
     */
    public function setVatNumber($vat_number)
    {
        $this->vat_number = $vat_number;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * @param mixed $phone
     * @return User
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getSlug()
    {
        return $this->slug;
    }

    /**
     * @param mixed $slug
     * @return User
     */
    public function setSlug($slug)
    {
        $this->slug = $slug;
        return $this;
    }

    public function __construct()
    {
        $this->generation_from = new ArrayCollection();
        $this->generation_to = new ArrayCollection();
        $this->notifications = new ArrayCollection();

        $this->created_at = new \DateTime();
        $this->companies = new ArrayCollection();
        $this->fields = new ArrayCollection();
    }

    public function __toString()
    {
        return $this->name;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getPassword(): string
    {
        return (string) $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getSalt()
    {
        // not needed when using the "bcrypt" algorithm in security.yaml
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    /**
     * @return mixed
     */
    public function getLogo()
    {
        return $this->logo;
    }

    /**
     * @param mixed $logo
     * @return User
     */
    public function setLogo($logo): User
    {
        $this->logo = $logo;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getProducts()
    {
        return $this->products;
    }

    public function getLogoUrl()
    {
        return '/logos/'.$this->logo;
    }

    /**
     * @param mixed $products
     * @return User
     */
    public function setProducts($products): User
    {
        $this->products = $products;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getAccountType()
    {
        return $this->account_type;
    }

    /**
     * @param mixed $account_type
     * @return User
     */
    public function setAccountType($account_type): User
    {
        $this->account_type = $account_type;
        return $this;
    }

    public function isVerified(): bool
    {
        return $this->isVerified;
    }

    public function setIsVerified(bool $isVerified): self
    {
        $this->isVerified = $isVerified;

        return $this;
    }

    /**
     * @return Collection|QuoteGeneration[]
     */
    public function getGenerationFrom(): Collection
    {
        return $this->generation_from;
    }

    public function addGenerationFrom(QuoteGeneration $generationFrom): self
    {
        if (!$this->generation_from->contains($generationFrom)) {
            $this->generation_from[] = $generationFrom;
            $generationFrom->setClient($this);
        }

        return $this;
    }

    public function removeGenerationFrom(QuoteGeneration $generationFrom): self
    {
        if ($this->generation_from->removeElement($generationFrom)) {
            // set the owning side to null (unless already changed)
            if ($generationFrom->getClient() === $this) {
                $generationFrom->setClient(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|QuoteGeneration[]
     */
    public function getGenerationTo(): Collection
    {
        return $this->generation_to;
    }

    public function addGenerationTo(QuoteGeneration $generationTo): self
    {
        if (!$this->generation_to->contains($generationTo)) {
            $this->generation_to[] = $generationTo;
            $generationTo->setProvider($this);
        }

        return $this;
    }

    public function removeGenerationTo(QuoteGeneration $generationTo): self
    {
        if ($this->generation_to->removeElement($generationTo)) {
            // set the owning side to null (unless already changed)
            if ($generationTo->getProvider() === $this) {
                $generationTo->setProvider(null);
            }
        }

        return $this;
    }

    /**
     * @return mixed
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * @param mixed $address
     * @return User
     */
    public function setAddress($address): self
    {
        $this->address = $address;
        return $this;
    }

    public function getIsSubscribed(): ?bool
    {

src/Form/UserType.php
<?php

namespace App\Form;

use App\Entity\User;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class UserType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('email')
            ->add('name')
            ->add('vat_number')
            ->add('phone')
            ->add('address')
            ->add('fields')
            ->add('is_subscribed')
            ->add('regions', ChoiceType::class, [
                'choices' => [
                    'Ariana'      => 'Ariana',
                    'Béja'        => 'Béja',
                    'Ben Arous'   => 'Ben Arous',
                    'Bizerte'     => 'Bizerte',
                    'Gabès'       => 'Gabès',
                    'Gafsa'       => 'Gafsa',
                    'Jendouba'    => 'Jendouba',
                    'Kairouan'    => 'Kairouan',
                    'Kasserine'   => 'Kasserine',
                    'Kébili'      => 'Kébili',
                    'Kef'         => 'Kef',
                    'Mahdia'      => 'Mahdia',
                    'Mannouba'    => 'Mannouba',
                    'Médennine'   => 'Médennine',
                    'Monastir'    => 'Monastir',
                    'Nabeul'      => 'Nabeul',
                    'Sfax'        => 'Sfax',
                    'Sidi Bouzid' => 'Sidi Bouzid',
                    'Siliana'     => 'Siliana',
                    'Sousse'      => 'Sousse',
                    'Tataouine'   => 'Tataouine',
                    'Tozeur'      => 'Tozeur',
                    'Tunis'       => 'Tunis',
                    'Zaghouan'    => 'Zaghouan',
                ],
                'placeholder' => '',
                'multiple' => true
            ])
            ->add('logo', FileType::class, [
                'data_class' => null,
                'required' => false
            ])
            ->add('password',RepeatedType::class, [
                'type' => PasswordType::class,
                'invalid_message' => 'Les mots de passe ne sont pas conformes',
                'required' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => User::class,
        ]);
    }
}

templates/user/_delete_form.html.twig
<form method="post" action="{{ path('user_delete', {'id': user.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ user.id) }}">
    <button class="btn">Delete</button>
</form>

templates/user/_form.html.twig
{{ form_start(form) }}
<div class="form-group">
    {{ form_label(form.email, 'Email') }}
    {{ form_widget(form.email, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.email) }}
</div>
<div class="form-group">
    {{ form_label(form.name, 'Nom/Raison Sociale') }}
    {{ form_widget(form.name, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.name) }}
</div>
<div class="form-group">
    {{ form_label(form.regions, 'Régions') }}
    {{ form_widget(form.regions, {attr: {class: 'select2 form-control'}}) }}
    {{ form_errors(form.regions) }}
</div>
<div class="form-group">
    {{ form_label(form.address, 'Adresse') }}
    {{ form_widget(form.address, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.address) }}
</div>
<div class="form-group">
    {{ form_label(form.fields, 'Secteurs d\'activité') }}
    {{ form_widget(form.fields, {attr: {class: 'select2 form-control'}}) }}
    {{ form_errors(form.fields) }}
</div>
<div class="form-group">
    {{ form_label(form.vat_number, 'Matricule Fisclae') }}
    {{ form_widget(form.vat_number, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.vat_number) }}
</div>
<div class="form-group">
    {{ form_label(form.phone, 'Téléphone') }}
    {{ form_widget(form.phone, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.phone) }}
</div>
<div class="form-group">
    {{ form_label(form.password.first, 'Mot de passe') }}
    {{ form_widget(form.password.first, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.password.first) }}
</div>
<div class="form-group">
    {{ form_label(form.password.second, 'Confirmer le mot de passe') }}
    {{ form_widget(form.password.second, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.password.second) }}
</div>
<div class="form-group">
    {{ form_label(form.logo, 'Logo') }}
    {{ form_widget(form.logo, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.logo) }}
</div>
<div class="form-group">
    <strong>Abonnement actif</strong><br>
    {{ form_widget(form.is_subscribed, {attr: {switch: 'primary'}}) }}
    {{ form_label(form.is_subscribed, ' ') }}
    {{ form_errors(form.is_subscribed) }}
</div>
    <button class="btn btn-primary">{{ button_label|default('Enregistrer') }}</button>
{{ form_end(form) }}

templates/user/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Modification du Fournisseur{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title">Modification du Fournisseur</h1>
        </div>
        <div class="card-body">
            {{ include('user/_form.html.twig') }}
        </div>
    </div>

{% endblock %}

templates/user/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}User index{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title float-left">Liste des fournisseurs</h1>
            <div class="float-right">
                <a class="btn btn-primary" href="{{ path('dashboard_user_new') }}">Ajouter un fournisseur</a>
            </div>
            <div class="clearfix"></div>
        </div>
        <div class="card-body">
            <table class="table">
                <thead>
                <tr>
                    <th class="text-center"><i class="fa fa-image"></i></th>
                    <th>Nom</th>
                    <th>Email</th>
                    <th>Téléphone</th>
                    <th>Matricule fiscale</th>
                    <th>Secteur d'activités</th>
                    <th>actions</th>
                </tr>
                </thead>
                <tbody>
                {% for user in users %}
                    <tr>
                        <td class="text-center"><img height="40" src="{{ user.logoUrl }}" alt=""></td>
                        <td>
                            {{ user.name }}
                        </td>
                        <td>{{ user.email }}</td>
                        <td>{{ user.phone }}</td>
                        <td>{{ user.vatNumber }}</td>
                        <td>
                            {% for field in user.fields %}
                            <span class="badge badge-info">{{ field }}</span>
                            {% endfor %}
                        </td>
                        <td>
                            <a class="btn btn-sm btn-success" href="{{ path('dashboard_user_show', {'id': user.id}) }}"><i class="fa fa-eye"></i></a>
                            <a class="btn btn-sm btn-info" href="{{ path('dashboard_user_edit', {'id': user.id}) }}"><i class="fa fa-edit"></i></a>
                        </td>
                    </tr>
                {% else %}
                    <tr>
                        <td colspan="9">Aucun fournisseur trouvé</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            <div class="navigation mt-4">
                {{ knp_pagination_render(users) }}
            </div>
        </div>
    </div>


{% endblock %}

templates/user/my_profile.html.twig
{% extends 'base.html.twig' %}

{% block title %}New User{% endblock %}

{% block body %}
    <div class="row flex-md-row-reverse">
        <div class="col-md-4">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Logo</h4>
                </div>
                <div class="card-body text-center">
                    <img style="max-width: 200px;" src="{{ user.logoUrl }}" alt="">
                </div>
            </div>
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Mot de passe</h4>
                </div>
                <div class="card-body">
                    <p>
                        <a class="btn btn-primary" href="{{ path('dashboard_user_update_password') }}">Modifier votre mot de passe</a>
                    </p>
                </div>
            </div>
        </div>
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">
                    <h1 class="card-title">Mon compte</h1>
                </div>
                <div class="card-body">
                    {% for message in app.flashes('success') %}
                        <div class="row">
                            <div class="col-md-12">
                                <div class="alert alert-success">
                                    <strong class="alert-heading"><i class="fa fa-check"></i> Succès !</strong> {{ message }}
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                    {{ form_start(form) }}
                    <div class="form-group">
                        {{ form_label(form.email, 'Email') }}
                        {{ form_widget(form.email, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.email) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.name, 'Nom/Raison Sociale') }}
                        {{ form_widget(form.name, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.name) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.address, 'Adresse') }}
                        {{ form_widget(form.address, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.address) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.region, 'Région') }}
                        {{ form_widget(form.region, {attr: {class: 'select2 form-control'}}) }}
                        {{ form_errors(form.region) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.field, 'Secteur d\'activité') }}
                        {{ form_widget(form.field, {attr: {class: 'select2 form-control'}}) }}
                        {{ form_errors(form.field) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.vat_number, 'Matricule Fisclae') }}
                        {{ form_widget(form.vat_number, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.vat_number) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.phone, 'Téléphone') }}
                        {{ form_widget(form.phone, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.phone) }}
                    </div>
                    <div class="form-group">
                        {{ form_label(form.logo, 'Logo') }}
                        {{ form_widget(form.logo, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.logo) }}
                    </div>
                    <button class="btn btn-primary">{{ button_label|default('Enregistrer') }}</button>
                    {{ form_end(form) }}
                </div>
            </div>
        </div>
    </div>
{% endblock %}

templates/user/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New User{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title">Nouveau Fournisseur</h1>
        </div>
        <div class="card-body">
            {{ include('user/_form.html.twig') }}
        </div>
    </div>

{% endblock %}

templates/user/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}User{% endblock %}

{% block body %}
    <h1>User</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ user.id }}</td>
            </tr>
            <tr>
                <th>Email</th>
                <td>{{ user.email }}</td>
            </tr>
            <tr>
                <th>Name</th>
                <td>{{ user.name }}</td>
            </tr>
            <tr>
                <th>Vat_number</th>
                <td>{{ user.vatNumber }}</td>
            </tr>
            <tr>
                <th>Phone</th>
                <td>{{ user.phone }}</td>
            </tr>
            <tr>
                <th>Logo</th>
                <td>{{ user.logo }}</td>
            </tr>
            <tr>
                <th>Roles</th>
                <td>{{ user.roles ? user.roles|json_encode : '' }}</td>
            </tr>
            <tr>
                <th>Password</th>
                <td>{{ user.password }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('user_index') }}">back to list</a>

    <a href="{{ path('user_edit', {'id': user.id}) }}">edit</a>

    {{ include('user/_delete_form.html.twig') }}
{% endblock %}

templates/user/update_password.html.twig
{% extends 'base.html.twig' %}

{% block title %}New User{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title">Modifier mon mot de passe</h1>
        </div>
        <div class="card-body">
            {% for message in app.flashes('success') %}
                <div class="row">
                    <div class="col-md-12">
                        <div class="alert alert-success">
                            <strong class="alert-heading"><i class="fa fa-check"></i> Succès !</strong> {{ message }}
                        </div>
                    </div>
                </div>
            {% endfor %}
            {{ form_start(form) }}
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        {{ form_label(form.password, 'Ancien mot de passe') }}
                        {{ form_widget(form.password, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.password) }}
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        {{ form_label(form.plainPassword.first, 'Nouveau mot de passe') }}
                        {{ form_widget(form.plainPassword.first, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.plainPassword.first) }}
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        {{ form_label(form.plainPassword.second, 'Confirmer le nouveau mot de passe') }}
                        {{ form_widget(form.plainPassword.second, {attr: {class: 'form-control'}}) }}
                        {{ form_errors(form.plainPassword.second) }}
                    </div>
                </div>
            </div>
            <button class="btn btn-primary">{{ button_label|default('Enregistrer') }}</button>
            {{ form_end(form) }}
        </div>
    </div>
{% endblock %}